#include "descriptor/descriptor.h"

#include "basso.h"

int main() {
	
	ITEM metallo_chiaro,metallo_scuro,legno,nero_lucido;
	ITEM Fbase,base;
	ITEM Ffermo,FvtE,FvbE,FvtF,FvbF,FvtA,FvbA,FvtB,FvbB,fermo;
	ITEM Fmanico,Fpunta,Fponte,Fgiunto,manico;
	ITEM FrbE,Frm1E,Frm2E,FrtE,FriE;
	ITEM FrbF,Frm1F,Frm2F,FrtF,FriF;
	ITEM FrbA,Frm1A,Frm2A,FrtA,FriA;
	ITEM FrbB,Frm1B,Frm2B,FrtB,FriB,reg;
	ITEM FcE,FgE,FcF,FgF,FcA,FgA,FcB,FgB,corde;
	ITEM basso;

	/**** setup della scena ****/
	set_background(BG_R,BG_G,BG_B,BG_REF);
	set_ambient_light(AL_R,AL_G,AL_B,AL_INT);
	create_point_light(L1_X,L1_Y,L1_Z,L1_R,L1_G,L1_B,L1_INT,L1_RANGE,"luce_1");
	create_warn_light(L2_X,L2_Y,L2_Z,L2_DX,L2_DY,L2_DZ,L2_R,L2_G,L2_B,L2_INT,L2_RANGE,L2_CONC,L2_CONE,0,0.0,0.0,0.0,0.0,"luce_2");
	create_warn_light(L3_X,L3_Y,L3_Z,L3_DX,L3_DY,L3_DZ,L3_R,L3_G,L3_B,L3_INT,L3_RANGE,L3_CONC,L3_CONE,0,0.0,0.0,0.0,0.0,"luce_3");
	create_point_light(L4_X,L4_Y,L4_Z,L4_R,L4_G,L4_B,L4_INT,L4_RANGE,"luce_4");

	/**** attributi ****/
	/* metallo chiaro */
	metallo_chiaro = create_attribute("metallo_chiaro");
	set_color(metallo_chiaro,LM_R,LM_G,LM_B,LM_PA,LM_PD);
	set_reflectivity(metallo_chiaro,LM_PS,LM_PHONG);
	set_transparency(metallo_chiaro,LM_MAXT,LM_MINT,LM_TPWR,LM_N);

	/* metallo scuro */
	metallo_scuro = create_attribute("metallo_scuro");
	set_color(metallo_scuro,DM_R,DM_G,DM_B,DM_PA,DM_PD);
	set_reflectivity(metallo_scuro,DM_PS,DM_PHONG);
	set_transparency(metallo_scuro,DM_MAXT,DM_MINT,DM_TPWR,DM_N);

	/* legno */
	legno = create_attribute("legno");
	set_color(legno,W_R,W_G,W_B,W_PA,W_PD);
	set_reflectivity(legno,W_PS,W_PHONG);
	set_transparency(legno,W_MAXT,W_MINT,W_TPWR,W_N);

	/* nero lucido */
	nero_lucido = create_attribute("lucido_nero");
	set_color(nero_lucido,SB_R,SB_G,SB_B,SB_PA,SB_PD);
	set_reflectivity(nero_lucido,SB_PS,SB_PHONG);
	set_transparency(nero_lucido,SB_MAXT,SB_MINT,SB_TPWR,SB_N);

	/************ oggetti ************/
	/* base */
	Fbase = read_nurbs("surfaces/base.db");
	set_attribute(Fbase,nero_lucido);
	base = create_list(Fbase,"base");

	/* fermo */
	// base del fermo
	Ffermo = read_nurbs("surfaces/fermo.db");
	set_attribute(Ffermo,metallo_chiaro);
	fermo = create_list(Ffermo,"fermo");
	// vite per la corda E
	FvbE = read_nurbs("surfaces/vbE.db");
	set_attribute(FvbE,metallo_chiaro);
	FvtE = read_nurbs("surfaces/vtE.db");
	set_attribute(FvtE,metallo_scuro);
	fermo = insert_in_list(fermo,FvbE);
	fermo = insert_in_list(fermo,FvtE);
	// vite per la corda F
	FvbF = read_nurbs("surfaces/vbF.db");
	set_attribute(FvbF,metallo_chiaro);
	FvtF = read_nurbs("surfaces/vtF.db");
	set_attribute(FvtF,metallo_scuro);
	fermo = insert_in_list(fermo,FvbF);
	fermo = insert_in_list(fermo,FvtF);
	// vite per la corda A
	FvbA = read_nurbs("surfaces/vbA.db");
	set_attribute(FvbA,metallo_chiaro);
	FvtA = read_nurbs("surfaces/vtA.db");
	set_attribute(FvtA,metallo_scuro);
	fermo = insert_in_list(fermo,FvbA);
	fermo = insert_in_list(fermo,FvtA);
	// vite per la corda B
	FvbB = read_nurbs("surfaces/vbB.db");
	set_attribute(FvbB,metallo_chiaro);
	FvtB = read_nurbs("surfaces/vtB.db");
	set_attribute(FvtB,metallo_scuro);
	fermo = insert_in_list(fermo,FvbB);
	fermo = insert_in_list(fermo,FvtB);

	/* manico */
	Fmanico = read_nurbs("surfaces/manico.db");
	set_scale(Fmanico,1.0,0.2,0.0125);
	set_translate(Fmanico,0.0,0.0,-1.5);
	set_projection_texture(Fmanico,legno,"textures/manico.hr",0,0,0.4,0.6);
	set_translate(Fmanico,0.0,0.0,1.5);
	set_scale(Fmanico,1.0,1.0/0.2,1.0/0.0125);
	manico = create_list(Fmanico,"manico");
	Fponte = read_nurbs("surfaces/ponte.db");
	set_attribute(Fponte,legno);
	manico = insert_in_list(manico,Fponte);
	Fgiunto = read_nurbs("surfaces/giunto.db");
	set_attribute(Fgiunto,legno);
	manico = insert_in_list(manico,Fgiunto);
	Fpunta = read_nurbs("surfaces/punta.db");
	set_attribute(Fpunta,nero_lucido);
	manico = insert_in_list(manico,Fpunta);

	/* regolazioni */
	// regolazioni per la corda E
	FrbE = read_nurbs("surfaces/rbE.db");
	set_attribute(FrbE,metallo_chiaro);
	reg = create_list(FrbE,"regolazioni");
	Frm1E = read_nurbs("surfaces/rm1E.db");
	set_attribute(Frm1E,metallo_chiaro);
	reg = insert_in_list(reg,Frm1E);
	Frm2E = read_nurbs("surfaces/rm2E.db");
	set_attribute(Frm2E,metallo_chiaro);
	reg = insert_in_list(reg,Frm2E);
	FriE = read_nurbs("surfaces/riE.db");
	set_attribute(FriE,metallo_scuro);
	reg = insert_in_list(reg,FriE);
	FrtE = read_nurbs("surfaces/rtE.db");
	set_attribute(FrtE,metallo_scuro);
	reg = insert_in_list(reg,FrtE);
	// regolazioni per la corda F
	FrbF = read_nurbs("surfaces/rbF.db");
	set_attribute(FrbF,metallo_chiaro);
	reg = insert_in_list(reg,FrbF);
	Frm1F = read_nurbs("surfaces/rm1F.db");
	set_attribute(Frm1F,metallo_chiaro);
	reg = insert_in_list(reg,Frm1F);
	Frm2F = read_nurbs("surfaces/rm2F.db");
	set_attribute(Frm2F,metallo_chiaro);
	reg = insert_in_list(reg,Frm2F);
	FriF = read_nurbs("surfaces/riF.db");
	set_attribute(FriF,metallo_scuro);
	reg = insert_in_list(reg,FriF);
	FrtF = read_nurbs("surfaces/rtF.db");
	set_attribute(FrtF,metallo_scuro);
	reg = insert_in_list(reg,FrtF);
	// regolazioni per la corda A
	FrbA = read_nurbs("surfaces/rbA.db");
	set_attribute(FrbA,metallo_chiaro);
	reg = insert_in_list(reg,FrbA);
	Frm1A = read_nurbs("surfaces/rm1A.db");
	set_attribute(Frm1A,metallo_chiaro);
	reg = insert_in_list(reg,Frm1A);
	Frm2A = read_nurbs("surfaces/rm2A.db");
	set_attribute(Frm2A,metallo_chiaro);
	reg = insert_in_list(reg,Frm2A);
	FriA = read_nurbs("surfaces/riA.db");
	set_attribute(FriA,metallo_scuro);
	reg = insert_in_list(reg,FriA);
	FrtA = read_nurbs("surfaces/rtA.db");
	set_attribute(FrtA,metallo_scuro);
	reg = insert_in_list(reg,FrtA);
	// regolazioni per la corda B
	FrbB = read_nurbs("surfaces/rbB.db");
	set_attribute(FrbB,metallo_chiaro);
	reg = insert_in_list(reg,FrbB);
	Frm1B = read_nurbs("surfaces/rm1B.db");
	set_attribute(Frm1B,metallo_chiaro);
	reg = insert_in_list(reg,Frm1B);
	Frm2B = read_nurbs("surfaces/rm2B.db");
	set_attribute(Frm2A,metallo_chiaro);
	reg = insert_in_list(reg,Frm2B);
	FriB = read_nurbs("surfaces/riB.db");
	set_attribute(FriB,metallo_scuro);
	reg = insert_in_list(reg,FriB);
	FrtB = read_nurbs("surfaces/rtB.db");
	set_attribute(FrtB,metallo_scuro);
	reg = insert_in_list(reg,FrtB);

	/* corde */
	// corda E
	FcE = read_nurbs("surfaces/cE.db");
	set_attribute(FcE,metallo_chiaro);
	corde = create_list(FcE,"corde");
	FgE = read_nurbs("surfaces/gE.db");
	set_attribute(FgE,metallo_chiaro);
	corde = insert_in_list(corde,FgE);
	// corda F
	FcF = read_nurbs("surfaces/cF.db");
	set_attribute(FcF,metallo_chiaro);
	corde = insert_in_list(corde,FcF);
	FgF = read_nurbs("surfaces/gF.db");
	set_attribute(FgF,metallo_chiaro);
	corde = insert_in_list(corde,FgF);
	// corda A
	FcA = read_nurbs("surfaces/cA.db");
	set_attribute(FcA,metallo_chiaro);
	corde = insert_in_list(corde,FcA);
	FgA = read_nurbs("surfaces/gA.db");
	set_attribute(FgA,metallo_chiaro);
	corde = insert_in_list(corde,FgA);
	// corda B
	FcB = read_nurbs("surfaces/cB.db");
	set_attribute(FcB,metallo_chiaro);
	corde = insert_in_list(corde,FcB);
	FgB = read_nurbs("surfaces/gB.db");
	set_attribute(FgB,metallo_chiaro);
	corde = insert_in_list(corde,FgB);

	/**** creazione del basso ****/
	basso = create_list(manico,"basso");
	basso = insert_in_list(basso,fermo);
	basso = insert_in_list(basso,base);
	basso = insert_in_list(basso,reg);
	basso = insert_in_list(basso,corde);

	/**** salvataggio della scena finale ****/
	save_scene("basso.md","basso",basso);

	return(0);
}

